<?php
/**
 * Generated by the WordPress Option Page generator
 * at http://jeremyhixon.com/wp-tools/option-page/
 */

 class TpostTelegramFetchSettings {
	private $telegram_fetch_settings_options;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'telegram_fetch_settings_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'telegram_fetch_settings_page_init' ) );
	}

	public function telegram_fetch_settings_add_plugin_page() {
		add_menu_page(
			'TelePost Fetch Settings', // page_title
			'TelePost Settings', // menu_title
			'manage_options', // capability
			'telegram-fetch-settings', // menu_slug
			array( $this, 'telegram_fetch_settings_create_admin_page' ), // function
			'dashicons-admin-generic', // icon_url
			2 // position
		);
	}

	public function telegram_fetch_settings_create_admin_page() {
		$this->telegram_fetch_settings_options = get_option( 'telegram_fetch_settings_option_name' ); ?>

		<script>

			function getTgUsersListTextBox(){
				return document.getElementById("source_telegram_channel_usernames_comma_seperated_0");
			}
			function getCatsListTextBox(){
				return document.getElementById("category_ids_comma_seperated_for_each_channel_set_one_id_1");
			}

			function deleteChannel(tgUsername){
				if(confirm('Are you sure to delete following channel?\n'+tgUsername))
				{
					var usernamesArr = getTgUsersListTextBox().value.split(',');
					var catsArr = getCatsListTextBox().value.split(',');
					var indexToDel = usernamesArr.indexOf(tgUsername);
					usernamesArr.splice(indexToDel , 1);
					catsArr.splice(indexToDel , 1);
					getTgUsersListTextBox().value = usernamesArr.toString();
					getCatsListTextBox().value = catsArr.toString();
					document.getElementById('submit').click();
				}
			}

			function addChannelToList(){
				var tgUsersListTextBox = getTgUsersListTextBox();
				var catsListTextBox = getCatsListTextBox();

			    var tgUser =	document.getElementById("tgUsername").value.trim();
				tgUsersListTextBox.value += (tgUsersListTextBox.value.length ==0 ? '' : ',') + tgUser;

				/*var tbl = document.getElementById('channelTable');
				var myTr = tbl.insertRow(-1);
				var myTd1 = myTr.insertCell(0);
				myTd1.innerHTML = tgUser;
				var myTd2 = myTr.insertCell(1);*/
				var catId = document.getElementById("tgCats").value;
				catsListTextBox.value += (catsListTextBox.value.length ==0 ? '' : ',') + catId;
				document.getElementById('submit').click();
				/*var catName = document.getElementById("tgCats").selectedOptions[0].text;
				myTd2.innerHTML = catName;

				var myTd3 = myTr.insertCell(2);
				myTd3.innerHTML = "<input type='button' onclick='deleteChannel(\""+tgUser+"\")' class='submitdelete' value='Delete'  />";*/
			}
		</script>
		<div class="wrap">
			<h2>Telegram Fetch Settings</h2>
			
			<?php settings_errors(); ?>
			<table id="channelTable" class="wp-list-table widefat fixed striped table-view-list posts">
				<tr>
					<td colspan="3">Channel Username:
						<input type="text" id="tgUsername" />
						<br/>
						Category:
						<select id="tgCats" style="margin-left: 58px;">
					<?php
						$categories = get_categories( array(
							'orderby' => 'name',
							'order'   => 'ASC',
							'hide_empty'      => false
						) );
							
						foreach( $categories as $category ) {
							echo '<option value="',esc_attr($category->term_id),'">',esc_html( $category->name ),'</option>' ;
							} ?>
						</select>
						<br/>
						<input type="button" style="margin-left: 116px;" id="btnAdd" value="Add Channel" onclick="addChannelToList()" />
					</td>
				</tr>
				<?php 
					$telegram_fetch_settings_options = get_option( 'telegram_fetch_settings_option_name' ); // Array of All Options
					$sourceChannels = $telegram_fetch_settings_options['source_telegram_channel_usernames_comma_seperated_0']; // Source Telegram Channel usernames comma seperated
					$sourceCatIds = $telegram_fetch_settings_options['category_ids_comma_seperated_for_each_channel_set_one_id_1']; // Category Ids comma seperated(For each channel set one id)
					
					$channelObjs =  explode(",", $sourceChannels);
					$catIds = explode(",", $sourceCatIds);
					$index = 0;
					foreach($channelObjs as $obj )
					{
						if(!isset($obj) || $obj=="" || empty($obj))
							continue;
						echo '<tr><td>',esc_html($obj),'</td>';
						foreach( $categories as $category )
							if($category->term_id == $catIds[$index])
								echo '<td>',esc_html($category->name),'</td>';
						echo "<td><input type='button' onclick='deleteChannel(\"",esc_html($obj),"\")' class='submitdelete' value='Delete'  /></td></tr>";
						$index++;
						
					}
				?>
			</table>
			<form method="post" action="options.php">
				<?php
					settings_fields( 'telegram_fetch_settings_option_group' );
					do_settings_sections( 'telegram-fetch-settings-admin' );
					submit_button();
				?>
			</form>
			<p>Last time cron executed: 
                <?php  
                    if(get_option('last_tg_cron_executed'))
                        $sgs_last_cron_time =   get_option('last_tg_cron_executed') ; 
                    else
                        $sgs_last_cron_time = "Not executed yet.";
                    echo esc_html($sgs_last_cron_time);
                ?>
            </p>
		</div>
	<?php }

	public function telegram_fetch_settings_page_init() {
		register_setting(
			'telegram_fetch_settings_option_group', // option_group
			'telegram_fetch_settings_option_name', // option_name
			array( $this, 'telegram_fetch_settings_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'telegram_fetch_settings_setting_section', // id
			'', // title
			array( $this, 'telegram_fetch_settings_section_info' ), // callback
			'telegram-fetch-settings-admin' // page
		);

		add_settings_field(
			'source_telegram_channel_usernames_comma_seperated_0', // id
			'',//'Source Telegram Channel usernames comma seperated', // title
			array( $this, 'source_telegram_channel_usernames_comma_seperated_0_callback' ), // callback
			'telegram-fetch-settings-admin', // page
			'telegram_fetch_settings_setting_section' // section
		);

		add_settings_field(
			'category_ids_comma_seperated_for_each_channel_set_one_id_1', // id
			'',//'Category Ids comma seperated(For each channel set one id)', // title
			array( $this, 'category_ids_comma_seperated_for_each_channel_set_one_id_1_callback' ), // callback
			'telegram-fetch-settings-admin', // page
			'telegram_fetch_settings_setting_section' // section
		);

		add_settings_field(
			'cron_schedule_to_fetch_telegram_posts_2', // id
			'Cron schedule to fetch Telegram posts', // title
			array( $this, 'cron_schedule_to_fetch_telegram_posts_2_callback' ), // callback
			'telegram-fetch-settings-admin', // page
			'telegram_fetch_settings_setting_section' // section
		);
	}

	public function telegram_fetch_settings_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['source_telegram_channel_usernames_comma_seperated_0'] ) ) {
			$sanitary_values['source_telegram_channel_usernames_comma_seperated_0'] = sanitize_text_field( $input['source_telegram_channel_usernames_comma_seperated_0'] );
		}

		if ( isset( $input['category_ids_comma_seperated_for_each_channel_set_one_id_1'] ) ) {
			$sanitary_values['category_ids_comma_seperated_for_each_channel_set_one_id_1'] = sanitize_text_field( $input['category_ids_comma_seperated_for_each_channel_set_one_id_1'] );
		}

		if ( isset( $input['cron_schedule_to_fetch_telegram_posts_2'] ) ) {
			$sanitary_values['cron_schedule_to_fetch_telegram_posts_2'] = $input['cron_schedule_to_fetch_telegram_posts_2'];
            $repeat = $sanitary_values['cron_schedule_to_fetch_telegram_posts_2'] ;
            wp_clear_scheduled_hook( 'tpost_sgs_scrapeTelegram_cron_event' );
            if ( ! wp_next_scheduled( 'tpost_sgs_scrapeTelegram_cron_event' ) ) {
                $start_time =time()+20;//70 secs from now
                wp_schedule_event( $start_time, $repeat, 'tpost_sgs_scrapeTelegram_cron_event' );
                echo esc_html("the schedule");
            }
		}

		return $sanitary_values;
	}

	public function telegram_fetch_settings_section_info() {
		
	}

	public function source_telegram_channel_usernames_comma_seperated_0_callback() {
		printf(
			'<input class="regular-text" style="display:none;" type="text" name="telegram_fetch_settings_option_name[source_telegram_channel_usernames_comma_seperated_0]" id="source_telegram_channel_usernames_comma_seperated_0" value="%s">',
			isset( $this->telegram_fetch_settings_options['source_telegram_channel_usernames_comma_seperated_0'] ) ? esc_attr( $this->telegram_fetch_settings_options['source_telegram_channel_usernames_comma_seperated_0']) : ''
		);
	}

	public function category_ids_comma_seperated_for_each_channel_set_one_id_1_callback() {
		printf(
			'<input class="regular-text" style="display:none;" type="text" name="telegram_fetch_settings_option_name[category_ids_comma_seperated_for_each_channel_set_one_id_1]" id="category_ids_comma_seperated_for_each_channel_set_one_id_1" value="%s">',
			isset( $this->telegram_fetch_settings_options['category_ids_comma_seperated_for_each_channel_set_one_id_1'] ) ? esc_attr( $this->telegram_fetch_settings_options['category_ids_comma_seperated_for_each_channel_set_one_id_1']) : ''
		);
	}

	public function cron_schedule_to_fetch_telegram_posts_2_callback() {
		?> <select name="telegram_fetch_settings_option_name[cron_schedule_to_fetch_telegram_posts_2]" id="cron_schedule_to_fetch_telegram_posts_2">
			<?php $selected = (isset( $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] ) && $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] === 'hourly') ? 'selected' : '' ; ?>
			<option <?php echo $selected; ?>>hourly</option>
			<?php $selected = (isset( $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] ) && $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] === 'twicedaily') ? 'selected' : '' ; ?>
			<option <?php echo $selected; ?>>twicedaily</option>
			<?php $selected = (isset( $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] ) && $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] === 'daily') ? 'selected' : '' ; ?>
			<option <?php echo $selected; ?>>daily</option>
			<?php $selected = (isset( $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] ) && $this->telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2'] === 'weekly') ? 'selected' : '' ; ?>
			<option <?php echo $selected; ?>>weekly</option>
		</select> <?php
	}

}
if ( is_admin() )
{
	$telegram_fetch_settings = new TpostTelegramFetchSettings();
    
}
/* 
 * Retrieve this value with:
 * $telegram_fetch_settings_options = get_option( 'telegram_fetch_settings_option_name' ); // Array of All Options
 * $source_telegram_channel_usernames_comma_seperated_0 = $telegram_fetch_settings_options['source_telegram_channel_usernames_comma_seperated_0']; // Source Telegram Channel usernames comma seperated
 * $category_ids_comma_seperated_for_each_channel_set_one_id_1 = $telegram_fetch_settings_options['category_ids_comma_seperated_for_each_channel_set_one_id_1']; // Category Ids comma seperated(For each channel set one id)
 * $cron_schedule_to_fetch_telegram_posts_2 = $telegram_fetch_settings_options['cron_schedule_to_fetch_telegram_posts_2']; // Cron schedule to fetch Telegram posts
 */

?>